#include "base.as"; 
#include "races.as"; 
 
racesManagerWithVehicleLimit races(); 
 
void main() 
{ 
    // Add the race like usual 
    array< array<double> > coords1 = { 
        {115.579, 25.4988, 436.872, 0, 39.1139, 0}, 
        {98.9354, 25.5164, 388.277, 0, -9.73406, 0},
        {94.3402, 25.5188, 282.096, 0, -4.33422, 0},
        {182.975, 25.5137, 129.634, 0, -73.4513, 0},
        {279.206, 26.6138, 234.789, 0, 153.583, 0},
        {175.167, 25.5232, 399.252, 0, -145.292, 0},
        {301.53, 26.9922, 329.829, 0, -24.6226, 0},
        {366.203, 12.9016, 180.467, 0, -42.8424, 0},
        {391.838, 11.6576, 353.597, 0, 163.98, 0},
        {236.032, 23.57, 468.278, 0, 91.8277, 0}
    }; 
    array< array<double> > coords2 = { 
        {89.9565, 22.5197, 447.647, 0, 67.3089, 0},
        {54.4795, 31.0339, 386.794, 0, 16.1477, 0},
        {108.74, 25.5216, 275.51, 0, -73.6741, 0},
        {141.205, 33.5984, 248.938, 0, -79.7118, 0},
        {164.042, 25.5152, 181.795, 0, -3.55662, 0},
        {212.179, 25.5135, 117.027, 0, -68.7519, 0},
        {296.48, 25.6953, 164.414, 0, 169.78, 0},
        {204.706, 25.5799, 330.987, 0, 123.686, 0},
        {170.939, 28.4828, 300.361, 0, 43.4783, 0},
        {186.649, 26.6099, 244.602, 0, -75.0127, 0},
        {202.316, 30.1116, 283.712, 0, -179.957, 0},
        {190.11, 25.5016, 402.798, 0, -156.181, 0},
        {251.119, 31.0449, 426.676, 0, -78.7687, 0},
        {377.456, 12.0963, 218.003, 0, -71.3626, 0},
        {374.784, 13.4516, 287.542, 0, 107.337, 0},
        {296.095, 27.5022, 314.641, 0, 125.646, 0}
    };
    array< array<double> > coords3 = {
        {123.613, 24.4726, 331.138, 0, -92.9539, 0},
        {149.15, 22.5579, 328.577, 0, -93.324, 0},
        {170.9, 25.3548, 328.39, 0, -94.8733, 0}
    };
    //int raceID_ShortbedChallenge = races.addRace("Shortbed Challenge", coords1, races.LAPS_NoLaps); 
 
    // Add some vehicles (when you don't add any vehicles, then all vehicles will be allowed) 
    //races.addVehicle(raceID_ShortbedChallenge, "Chevrolet S10 Short Bed"); 
    //races.addVehicle(raceID_ShortbedChallenge, "1981 Datsun 720 King Cab 4x4"); 
    //races.addVehicle(raceID_ShortbedChallenge, "Ford F-150 SVT Lightning (1992)"); 
    //races.addVehicle(raceID_ShortbedChallenge, "Ford F-150 Short Bed 4x2 (1992)"); 
    //races.addVehicle(raceID_ShortbedChallenge, "Ford F-150 Short Bed 4x4 (1992)"); 
    //races.addVehicle(raceID_ShortbedChallenge, "Ford F-150 Flareside (1992)"); 
    //races.addVehicle(raceID_ShortbedChallenge, "Ford F-150 Short Bed 4WD (1984)"); 
    //races.addVehicle(raceID_ShortbedChallenge, "Ford F-150 Short Bed 2WD (1984)"); 
    //races.addVehicle(raceID_ShortbedChallenge, "Ford F-150 Short Bed 4x2 (1987)"); 
    //races.addVehicle(raceID_ShortbedChallenge, "Ford F-150 Short Bed 4x4 (1987)"); 
    //races.addVehicle(raceID_ShortbedChallenge, "Ford F-150 Short Bed (1976)"); 
    //races.addVehicle(raceID_ShortbedChallenge, "Ford F-150 Short Bed (1979)"); 
    //races.addVehicle(raceID_ShortbedChallenge, "Toyota Hilux mod"); 

    //int raceID_BiomesChallenge = races.addRace("Biomes Challenge", coords1, races.LAPS_NoLaps); 
    //int raceID_BiomesMudrace = races.addRace("Biomes Mud Challenge", coords2, races.LAPS_NoLaps); 
    int raceID_OffroadDerbyRace = races.addRace("Derbymutt's Offroad Course - Desert 1 - Main Track", coords1, races.LAPS_NoLaps, "OffroadDerby-chp", "OffroadDerby-start", "OffroadDerby-end"); 
    int raceID_OffroadDerbyRace2 = races.addRace("Derbymutt's Offroad Course - Desert 1 - Trailblazer", coords2, races.LAPS_NoLaps, "OffroadDerby-start2", "OffroadDerby-start2", "OffroadDerby-start2"); 
    int raceID_OffroadDerbyRace3 = races.addRace("Derbymutt's Offroad Course - Desert 1 - Mud Pit", coords3, races.LAPS_NoLaps, "OffroadDerby-start2", "OffroadDerby-start", "OffroadDerby-end"); 
} 
 
 
 
// Other stuff (No race specific stuff under this line) 
 
class racesManagerWithVehicleLimit : racesManager 
{ 
    dictionary vehicleData; 
    double lastMessageTime; 
 
    racesManagerWithVehicleLimit() 
    { 
        super(); 
        lastMessageTime = 0.0; 
    } 
 
    // extend this method 
    void startRace(int raceID) /*override*/ 
    { 
        bool allow = true; 
 
        // Do we have vehicle data for this race? 
        array<string>@ vehicles = null; 
        if(vehicleData.get("race_"+raceID, @vehicles)) 
        { 
            // Get the name of the current truck 
            string truckName = "avatar"; 
            BeamClass@ truck = game.getCurrentTruck(); 
            if(truck !is null) 
                truckName = truck.getTruckName(); 
 
            if(vehicles.find(truckName)<0) 
                allow = false; 
        } 
 
        if(allow) 
            racesManager::startRace(raceID); 
        else  
        { 
            // Avoid message spam (in exceptional cases) 
            if((game.getTime()-this.lastMessageTime)>5.0) 
            { 
                this.lastMessageTime = game.getTime(); 
 
                this.message("Race "+this.raceList[raceID].raceName+" can only be started with one of the following vehicles:", "information.png"); 
                this.message(arrayToString(vehicles), "information.png"); 
            } 
        } 
    } 
 
    void addVehicle(int raceID, string vehicleName) 
    { 
        array<string>@ vehicles = null; 
        if(!vehicleData.get("race_"+raceID, @vehicles)) 
        { 
            array<string> vehicles2 = {}; 
            @vehicles = @vehicles2; 
            vehicleData.set("race_"+raceID, @vehicles); 
        } 
 
        vehicles.insertLast(vehicleName); 
    } 
} 
 
string arrayToString(array<string>@ arr) 
{ 
    string result = ""; 
    if(arr !is null) for(uint i=0; i<arr.length(); ++i) 
    { 
        result += arr[i]; 
        if(i!=arr.length()-1) result += ", "; 
    } 
    return result; 
}